<template>
  <div class="row">
    <div class="col-7">
      <div class="d-flex justify-content-between align-items-center">
        <h3>Survey Builder</h3>
        <small v-if="!showCode">
          <a @click.prevent="showCode = true" href="./view?showCode=true">view code</a>
        </small>
        <small v-else @click="showCode = false">
          <a @click.prevent="showCode = true" href="./view?showCode=false">view graphical</a>
        </small>
      </div>

      <graphical-view
        v-if="!showCode"
        :selected="control"
        :controls="survey.controls"
        @controlSelected="controlSelected"
      />
      <code-view v-else v-model="survey" />
    </div>
    <div class="col-5">
      <div class="sticky-top">
        <h3>Details</h3>
        <survey-details v-model="survey" :editMode="editMode" />
        <h3>Add questions</h3>
        <control-adder @controlAdded="controlAdded" />
        <h3>Properties</h3>
        <control-properties :control="control" :survey="survey" />
      </div>
    </div>
  </div>
</template>

<script>
import ObjectId from "bson-objectid";
import api from "@/services/api.service";

import graphicalView from "./GraphicalView.vue";
import codeView from "./CodeView.vue";
import controlProperties from "./ControlProperties.vue";
import controlAdder from "./ControlAdder.vue";
import surveyDetails from "./SurveyDetails.vue";

export default {
  components: {
    graphicalView,
    codeView,
    controlProperties,
    controlAdder,
    surveyDetails
  },
  methods: {
    controlSelected(control) {
      this.control = control;
    },
    controlAdded(control) {
      this.survey.controls.push(control);
      this.control = control;
    }
  },
  data() {
    return {
      editMode: false,
      showCode: false,
      control: null,
      controls: [],
      survey: {
        name: "",
        _id: "",
        controls: []
      }
    };
  },
  async created() {
    this.editMode = !this.$route.matched.some(
      ({ name }) => name === "survey-builder-new"
    );

    this.survey._id = ObjectId();

    if (this.editMode) {
      try {
        const id = this.$route.params.id;
        this.survey._id = id;
        const { data } = await api.get(`/surveys/${this.survey._id}`);
        this.survey = data;
      } catch (e) {
        console.log("something went wrong:", e);
      }
    }
  }
};
</script>

<style scoped>
.no-outline {
  outline: none;
}
</style>

